/*
 * Blockdaemon REST API
 *
 * Blockdaemon REST API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://docs.blockdaemon.com/reference/rest-api-overview)  ### Currently supported protocols:  * algorand   * mainnet * avalanche    * mainnet-c/testnet-c * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/holesky/sepolia * fantom   * mainnet/testnet * litecoin   * mainnet/testnet * near   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet/amoy * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * tron   * mainnet/nile * xrp   * mainnet  ### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// TxPage struct for TxPage
type TxPage struct {
	// The number of items in txs.
	Total *int32       `json:"total,omitempty"`
	Data  *[]Tx        `json:"data,omitempty"`
	Meta  NullableMeta `json:"meta,omitempty"`
}

// NewTxPage instantiates a new TxPage object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTxPage() *TxPage {
	this := TxPage{}
	return &this
}

// NewTxPageWithDefaults instantiates a new TxPage object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTxPageWithDefaults() *TxPage {
	this := TxPage{}
	return &this
}

// GetTotal returns the Total field value if set, zero value otherwise.
func (o *TxPage) GetTotal() int32 {
	if o == nil || o.Total == nil {
		var ret int32
		return ret
	}
	return *o.Total
}

// GetTotalOk returns a tuple with the Total field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxPage) GetTotalOk() (*int32, bool) {
	if o == nil || o.Total == nil {
		return nil, false
	}
	return o.Total, true
}

// HasTotal returns a boolean if a field has been set.
func (o *TxPage) HasTotal() bool {
	if o != nil && o.Total != nil {
		return true
	}

	return false
}

// SetTotal gets a reference to the given int32 and assigns it to the Total field.
func (o *TxPage) SetTotal(v int32) {
	o.Total = &v
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *TxPage) GetData() []Tx {
	if o == nil || o.Data == nil {
		var ret []Tx
		return ret
	}
	return *o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxPage) GetDataOk() (*[]Tx, bool) {
	if o == nil || o.Data == nil {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *TxPage) HasData() bool {
	if o != nil && o.Data != nil {
		return true
	}

	return false
}

// SetData gets a reference to the given []Tx and assigns it to the Data field.
func (o *TxPage) SetData(v []Tx) {
	o.Data = &v
}

// GetMeta returns the Meta field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *TxPage) GetMeta() Meta {
	if o == nil || o.Meta.Get() == nil {
		var ret Meta
		return ret
	}
	return *o.Meta.Get()
}

// GetMetaOk returns a tuple with the Meta field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *TxPage) GetMetaOk() (*Meta, bool) {
	if o == nil {
		return nil, false
	}
	return o.Meta.Get(), o.Meta.IsSet()
}

// HasMeta returns a boolean if a field has been set.
func (o *TxPage) HasMeta() bool {
	if o != nil && o.Meta.IsSet() {
		return true
	}

	return false
}

// SetMeta gets a reference to the given NullableMeta and assigns it to the Meta field.
func (o *TxPage) SetMeta(v Meta) {
	o.Meta.Set(&v)
}

// SetMetaNil sets the value for Meta to be an explicit nil
func (o *TxPage) SetMetaNil() {
	o.Meta.Set(nil)
}

// UnsetMeta ensures that no value is present for Meta, not even an explicit nil
func (o *TxPage) UnsetMeta() {
	o.Meta.Unset()
}

func (o TxPage) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Total != nil {
		toSerialize["total"] = o.Total
	}
	if o.Data != nil {
		toSerialize["data"] = o.Data
	}
	if o.Meta.IsSet() {
		toSerialize["meta"] = o.Meta.Get()
	}
	return json.Marshal(toSerialize)
}

type NullableTxPage struct {
	value *TxPage
	isSet bool
}

func (v NullableTxPage) Get() *TxPage {
	return v.value
}

func (v *NullableTxPage) Set(val *TxPage) {
	v.value = val
	v.isSet = true
}

func (v NullableTxPage) IsSet() bool {
	return v.isSet
}

func (v *NullableTxPage) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTxPage(val *TxPage) *NullableTxPage {
	return &NullableTxPage{value: val, isSet: true}
}

func (v NullableTxPage) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTxPage) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
